extends Piece

class_name Rook

func _init(is_white: bool, position: Vector2):
	super._init(is_white, position)

func get_valid_moves(board_state: Array, pos: Vector2) -> Array[Vector2]:
	var valid_moves = []
	var x = pos.x
	var y = pos.y

	# Check moves to the right
	for i in range(x + 1, 8):
		if board_state[i][y] == 0:
			valid_moves.append(Vector2(i, y))
		elif board_state[i][y].is_white != is_white:
			valid_moves.append(Vector2(i, y))
			break
		else:
			break

	# Check moves to the left
	for i in range(x - 1, -1, -1):
		if board_state[i][y] == 0:
			valid_moves.append(Vector2(i, y))
		elif board_state[i][y].is_white != is_white:
			valid_moves.append(Vector2(i, y))
			break
		else:
			break

	# Check moves upwards
	for i in range(y - 1, -1, -1):
		if board_state[x][i] == 0:
			valid_moves.append(Vector2(x, i))
		elif board_state[x][i].is_white != is_white:
			valid_moves.append(Vector2(x, i))
			break
		else:
			break

	# Check moves downwards
	for i in range(y + 1, 8):
		if board_state[x][i] == 0:
			valid_moves.append(Vector2(x, i))
		elif board_state[x][i].is_white != is_white:
			valid_moves.append(Vector2(x, i))
			break
		else:
			break

	return valid_moves
